-------------------------------------------
--- Author: Ketho (EU-Boulderfist)		---
--- Created: 2011.09.20					---
--- License: Public Domain				---
-------------------------------------------
--- kGuildNotes		v0.10  [2011.09.20]	---
-------------------------------------------
--- Curse			N/A
--- WoWInterface	N/A

local format = format
local delay = 0
local db, viewOfficer
local noop = function() end

-- delay initialization, because some guild API is not readily available (even after ADDON_LOADED)
local function OnUpdate(self, elapsed)
	delay = delay + elapsed
	if delay > 5 then
		if not IsInGuild() then
			self:SetScript("OnUpdate", noop)
			return
		end
		local guild = GetGuildInfo("player")
		kGuildNotesDB[guild] = kGuildNotesDB[guild] or {}
		db = kGuildNotesDB[guild]
		viewOfficer = CanViewOfficerNote()
		self:RegisterEvent("GUILD_ROSTER_UPDATE")
		self:SetScript("OnUpdate", noop)
	end
end

local cache = {}
cache["PRIEST"] = "A4A4A4" -- white->gray color exception

local function GetClassColor(class)
	if cache[class] then
		return cache[class]
	else
		cache[class] = format("%02X%02X%02X", RAID_CLASS_COLORS[class].r*255, RAID_CLASS_COLORS[class].g*255, RAID_CLASS_COLORS[class].b*255)
		return cache[class]
	end
end

local cd = 0
local GetGuildRosterInfo = GetGuildRosterInfo

local function OnEvent(self, event, ...)
	if event == "ADDON_LOADED" and ... == "kGuildNotes" then
		kGuildNotesDB = kGuildNotesDB or {}
		self:UnregisterEvent("ADDON_LOADED")
		self:SetScript("OnUpdate", OnUpdate)
	elseif event == "GUILD_ROSTER_UPDATE" then
		if time() > cd then -- throttle
			cd = time() + 2
			for i = 1, GetNumGuildMembers() do
				local name, _, _, _, _, _, publicNote, officerNote, _, _, englishClass = GetGuildRosterInfo(i)
				db[name] = db[name] or {}
				local classColor = GetClassColor(englishClass)
				if db[name][1] and db[name][1] ~= publicNote then
					local text
					if db[name][1] == "" then
						text = publicNote
					else
						text = format("%s |cff%s->|r %s", db[name][1], classColor, publicNote == "" and "|cffFF0000N/A|r" or publicNote)
					end
					print(format("|cff%s|Hplayer:%s|h[%s]|h|r %s", classColor, name, name, text))
				end
				if viewOfficer then
					if db[name][2] and db[name][2] ~= officerNote then
						local text
						if db[name][2] == "" then
							text = officerNote
						else
							text = format("%s |cff%s->|r %s", db[name][2], classColor, officerNote == "" and "|cffFF0000N/A|r" or officerNote)
						end
						print(format("|cffFF7F00[%s]|r |cff%s|Hplayer:%s|h[%s]|h|r %s", OFFICER_NOTE_COLON, classColor, name, name, text))
					end
					db[name][2] = officerNote
				end
				db[name][1] = publicNote
			end
		end
	end
end

local f = CreateFrame("Frame")
f:RegisterEvent("ADDON_LOADED")
f:SetScript("OnEvent", OnEvent)